﻿
''' <summary>
''' Hilfsklasse zum Erstellen von <see cref="DisplayItem(Of T)"/>.
''' </summary>
Public NotInheritable Class DisplayItem
    Private Sub New()
    End Sub

    ''' <summary>
    ''' Erstellt ein <see cref="DisplayItem(Of T)"/>.
    ''' </summary>
    Public Shared Function Create(Of T)(NewDisplayText As String, NewValue As T) As DisplayItem(Of T)
        Return New DisplayItem(Of T)(NewDisplayText, NewValue)
    End Function

End Class

''' <summary>
''' Kapselt einen Wert und verknüpft ihn mit einem Text, der dargestellt wird.
''' </summary>
''' <typeparam name="T">Der Typ des gekapselten Wertes.</typeparam>
Public Class DisplayItem(Of T)

    ''' <summary>
    ''' Der angezeigte Text.
    ''' </summary>
    Public Overridable Property DisplayText As String

    ''' <summary>
    ''' Der gekapselte Wert.
    ''' </summary>
    Public Property Value As T

    <DebuggerStepThrough()> _
    Public Sub New(NewDisplayText As String, NewValue As T)
        _DisplayText = NewDisplayText
        _Value = NewValue
    End Sub

    ''' <summary>
    ''' Gibt den Inhalt der <see cref="DisplayText"/>-Property zurück.
    ''' </summary>
    <DebuggerStepThrough()> _
    Public Overrides Function ToString() As String
        Return DisplayText
    End Function

End Class
