﻿
Namespace Emit

    ''' <summary>
    ''' Ein Sichtbarkeitsmodifikator für Member.
    ''' </summary>
    Public Enum AccessModifiers As Integer
        ''' <summary>
        ''' Nur in der Klasse sichtbar, in dem der Member deklariert ist.
        ''' </summary>
        [Private] = 1
        ''' <summary>
        ''' Nur in der Klasse sichtbar, in dem der Member deklariert ist, und in Klassen, die von dieser Klasse erben.
        ''' </summary>
        Family = 2
        ''' <summary>
        ''' Nur in Assembly sichtbar, in dem der Member deklariert ist.
        ''' </summary>
        Assembly = 3
        ''' <summary>
        ''' Nur in der Klasse sichtbar, in dem der Member deklariert ist, und in Klassen, die von dieser Klasse erben und sich in der Assembly befinden, in der der Member deklariert ist.
        ''' </summary>
        FamilyAndAssembly = 4
        ''' <summary>
        ''' Nur in der Klasse sichtbar, in dem der Member deklariert ist, und in Klassen, die von dieser Klasse erben oder sich in der Assembly befinden, in der der Member deklariert ist.
        ''' </summary>
        FamilyOrAssembly = 5
        ''' <summary>
        ''' Überall sichtbar.
        ''' </summary>
        [Public] = 6
    End Enum

End Namespace
