﻿
Imports System.Runtime.CompilerServices
Imports System.Reflection
Imports System.Reflection.Emit

Namespace Emit.IL

    ''' <summary>
    ''' Beinhaltet Extension-Methoden für die <see cref="ILGenerator"/>-Klasse, welche nach den möglichen OpCodes <see cref="OpCodes"/> benannt sind und nur gültige Parameter zulassen.
    ''' </summary>
    Public Module IL

#Region "Primitive"

        ''' <summary>
        ''' add : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Add(Target As ILGenerator)
            Target.Emit(OpCodes.Add)
        End Sub

        ''' <summary>
        ''' add.ovf : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Add_Ovf(Target As ILGenerator)
            Target.Emit(OpCodes.Add_Ovf)
        End Sub

        ''' <summary>
        ''' add.ovf.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Add_Ovf_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Add_Ovf_Un)
        End Sub

        ''' <summary>
        ''' and : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [And](Target As ILGenerator)
            Target.Emit(OpCodes.And)
        End Sub

        ''' <summary>
        ''' arglist : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Arglist(Target As ILGenerator)
            Target.Emit(OpCodes.Arglist)
        End Sub

        ''' <summary>
        ''' box : Primitive(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Box(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Box, TypeArgument)
        End Sub

        ''' <summary>
        ''' br : Primitive(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Br(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Br, LabelArgument)
        End Sub

        ''' <summary>
        ''' break : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Break(Target As ILGenerator)
            Target.Emit(OpCodes.Break)
        End Sub

        ''' <summary>
        ''' brfalse : Primitive(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Brfalse(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Brfalse, LabelArgument)
        End Sub

        ''' <summary>
        ''' brtrue : Primitive(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Brtrue(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Brtrue, LabelArgument)
        End Sub

        ''' <summary>
        ''' call : Primitive(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Call](Target As ILGenerator, ConstructorArgument As ConstructorInfo)
            Target.Emit(OpCodes.Call, ConstructorArgument)
        End Sub

        ''' <summary>
        ''' call : Primitive(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Call](Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Call, MethodArgument)
        End Sub

        ''' <summary>
        ''' calli : Primitive(InlineSig)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Calli(Target As ILGenerator, SignatureArgument As SignatureHelper)
            Target.Emit(OpCodes.Calli, SignatureArgument)
        End Sub

        ''' <summary>
        ''' ceq : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ceq(Target As ILGenerator)
            Target.Emit(OpCodes.Ceq)
        End Sub

        ''' <summary>
        ''' cgt : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Cgt(Target As ILGenerator)
            Target.Emit(OpCodes.Cgt)
        End Sub

        ''' <summary>
        ''' cgt.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Cgt_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Cgt_Un)
        End Sub

        ''' <summary>
        ''' ckfinite : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ckfinite(Target As ILGenerator)
            Target.Emit(OpCodes.Ckfinite)
        End Sub

        ''' <summary>
        ''' clt : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Clt(Target As ILGenerator)
            Target.Emit(OpCodes.Clt)
        End Sub

        ''' <summary>
        ''' clt.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Clt_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Clt_Un)
        End Sub

        ''' <summary>
        ''' conv.i : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_I(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_I)
        End Sub

        ''' <summary>
        ''' conv.i1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_I1(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_I1)
        End Sub

        ''' <summary>
        ''' conv.i2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_I2(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_I2)
        End Sub

        ''' <summary>
        ''' conv.i4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_I4(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_I4)
        End Sub

        ''' <summary>
        ''' conv.i8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_I8(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_I8)
        End Sub

        ''' <summary>
        ''' conv.ovf.i : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I)
        End Sub

        ''' <summary>
        ''' conv.ovf.i.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.i1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I1(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I1)
        End Sub

        ''' <summary>
        ''' conv.ovf.i1.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I1_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I1_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.i2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I2(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I2)
        End Sub

        ''' <summary>
        ''' conv.ovf.i2.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I2_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I2_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.i4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I4(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I4)
        End Sub

        ''' <summary>
        ''' conv.ovf.i4.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I4_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I4_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.i8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I8(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I8)
        End Sub

        ''' <summary>
        ''' conv.ovf.i8.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_I8_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_I8_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.u : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U)
        End Sub

        ''' <summary>
        ''' conv.ovf.u.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.u1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U1(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U1)
        End Sub

        ''' <summary>
        ''' conv.ovf.u1.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U1_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U1_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.u2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U2(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U2)
        End Sub

        ''' <summary>
        ''' conv.ovf.u2.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U2_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U2_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.u4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U4(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U4)
        End Sub

        ''' <summary>
        ''' conv.ovf.u4.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U4_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U4_Un)
        End Sub

        ''' <summary>
        ''' conv.ovf.u8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U8(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U8)
        End Sub

        ''' <summary>
        ''' conv.ovf.u8.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_Ovf_U8_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_Ovf_U8_Un)
        End Sub

        ''' <summary>
        ''' conv.r.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_R_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_R_Un)
        End Sub

        ''' <summary>
        ''' conv.r4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_R4(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_R4)
        End Sub

        ''' <summary>
        ''' conv.r8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_R8(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_R8)
        End Sub

        ''' <summary>
        ''' conv.u : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_U(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_U)
        End Sub

        ''' <summary>
        ''' conv.u1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_U1(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_U1)
        End Sub

        ''' <summary>
        ''' conv.u2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_U2(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_U2)
        End Sub

        ''' <summary>
        ''' conv.u4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_U4(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_U4)
        End Sub

        ''' <summary>
        ''' conv.u8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Conv_U8(Target As ILGenerator)
            Target.Emit(OpCodes.Conv_U8)
        End Sub

        ''' <summary>
        ''' cpblk : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Cpblk(Target As ILGenerator)
            Target.Emit(OpCodes.Cpblk)
        End Sub

        ''' <summary>
        ''' div : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Div(Target As ILGenerator)
            Target.Emit(OpCodes.Div)
        End Sub

        ''' <summary>
        ''' div.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Div_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Div_Un)
        End Sub

        ''' <summary>
        ''' dup : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Dup(Target As ILGenerator)
            Target.Emit(OpCodes.Dup)
        End Sub

        ''' <summary>
        ''' endfilter : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Endfilter(Target As ILGenerator)
            Target.Emit(OpCodes.Endfilter)
        End Sub

        ''' <summary>
        ''' endfinally : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Endfinally(Target As ILGenerator)
            Target.Emit(OpCodes.Endfinally)
        End Sub

        ''' <summary>
        ''' initblk : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Initblk(Target As ILGenerator)
            Target.Emit(OpCodes.Initblk)
        End Sub

        ''' <summary>
        ''' jmp : Primitive(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Jmp(Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Jmp, MethodArgument)
        End Sub

        ''' <summary>
        ''' ldarg : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarg(Target As ILGenerator, Int16Argument As Int16)
            Target.Emit(OpCodes.Ldarg, Int16Argument)
        End Sub

        ''' <summary>
        ''' ldarga : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarga(Target As ILGenerator, Int16Argument As Int16)
            Target.Emit(OpCodes.Ldarga, Int16Argument)
        End Sub

        ''' <summary>
        ''' ldc.i4 : Primitive(InlineI)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4(Target As ILGenerator, Int32Argument As Int32)
            Target.Emit(OpCodes.Ldc_I4, Int32Argument)
        End Sub

        ''' <summary>
        ''' ldc.i8 : Primitive(InlineI8)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I8(Target As ILGenerator, Int64Argument As Int64)
            Target.Emit(OpCodes.Ldc_I8, Int64Argument)
        End Sub

        ''' <summary>
        ''' ldc.r4 : Primitive(ShortInlineR)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_R4(Target As ILGenerator, SingleArgument As Single)
            Target.Emit(OpCodes.Ldc_R4, SingleArgument)
        End Sub

        ''' <summary>
        ''' ldc.r8 : Primitive(InlineR)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_R8(Target As ILGenerator, DoubleArgument As Double)
            Target.Emit(OpCodes.Ldc_R8, DoubleArgument)
        End Sub

        ''' <summary>
        ''' ldftn : Primitive(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldftn(Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Ldftn, MethodArgument)
        End Sub

        ''' <summary>
        ''' ldind.i : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_I(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_I)
        End Sub

        ''' <summary>
        ''' ldind.i1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_I1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_I1)
        End Sub

        ''' <summary>
        ''' ldind.i2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_I2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_I2)
        End Sub

        ''' <summary>
        ''' ldind.i4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_I4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_I4)
        End Sub

        ''' <summary>
        ''' ldind.i8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_I8(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_I8)
        End Sub

        ''' <summary>
        ''' ldind.r4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_R4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_R4)
        End Sub

        ''' <summary>
        ''' ldind.r8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_R8(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_R8)
        End Sub

        ''' <summary>
        ''' ldind.ref : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_Ref(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_Ref)
        End Sub

        ''' <summary>
        ''' ldind.u1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_U1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_U1)
        End Sub

        ''' <summary>
        ''' ldind.u2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_U2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_U2)
        End Sub

        ''' <summary>
        ''' ldind.u4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldind_U4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldind_U4)
        End Sub

        ''' <summary>
        ''' ldloc : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc(Target As ILGenerator, Int16Argument As Int16)
            Target.Emit(OpCodes.Ldloc, Int16Argument)
        End Sub

        ''' <summary>
        ''' ldloc : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc(Target As ILGenerator, LocalArgument As LocalBuilder)
            Target.Emit(OpCodes.Ldloc, LocalArgument)
        End Sub

        ''' <summary>
        ''' ldloca : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloca(Target As ILGenerator, Int16Argument As Int16)
            Target.Emit(OpCodes.Ldloca, Int16Argument)
        End Sub

        ''' <summary>
        ''' ldloca : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloca(Target As ILGenerator, LocalArgument As LocalBuilder)
            Target.Emit(OpCodes.Ldloca, LocalArgument)
        End Sub

        ''' <summary>
        ''' ldnull : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldnull(Target As ILGenerator)
            Target.Emit(OpCodes.Ldnull)
        End Sub

        ''' <summary>
        ''' ldtoken : Primitive(InlineTok)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldtoken(Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Ldtoken, MethodArgument)
        End Sub

        ''' <summary>
        ''' ldtoken : Primitive(InlineTok)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldtoken(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Ldtoken, FieldArgument)
        End Sub

        ''' <summary>
        ''' ldtoken : Primitive(InlineTok)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldtoken(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Ldtoken, TypeArgument)
        End Sub

        ''' <summary>
        ''' ldvirtftn : Primitive(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldvirtftn(Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Ldvirtftn, MethodArgument)
        End Sub

        ''' <summary>
        ''' leave : Primitive(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Leave(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Leave, LabelArgument)
        End Sub

        ''' <summary>
        ''' leave.s : Primitive(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Leave_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Leave_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' localloc : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Localloc(Target As ILGenerator)
            Target.Emit(OpCodes.Localloc)
        End Sub

        ''' <summary>
        ''' mkrefany : Primitive(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Mkrefany(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Mkrefany, TypeArgument)
        End Sub

        ''' <summary>
        ''' mul : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Mul(Target As ILGenerator)
            Target.Emit(OpCodes.Mul)
        End Sub

        ''' <summary>
        ''' mul.ovf : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Mul_Ovf(Target As ILGenerator)
            Target.Emit(OpCodes.Mul_Ovf)
        End Sub

        ''' <summary>
        ''' mul.ovf.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Mul_Ovf_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Mul_Ovf_Un)
        End Sub

        ''' <summary>
        ''' neg : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Neg(Target As ILGenerator)
            Target.Emit(OpCodes.Neg)
        End Sub

        ''' <summary>
        ''' nop : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Nop(Target As ILGenerator)
            Target.Emit(OpCodes.Nop)
        End Sub

        ''' <summary>
        ''' not : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Not](Target As ILGenerator)
            Target.Emit(OpCodes.Not)
        End Sub

        ''' <summary>
        ''' or : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Or](Target As ILGenerator)
            Target.Emit(OpCodes.Or)
        End Sub

        ''' <summary>
        ''' pop : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Pop(Target As ILGenerator)
            Target.Emit(OpCodes.Pop)
        End Sub

        ''' <summary>
        ''' refanytype : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Refanytype(Target As ILGenerator)
            Target.Emit(OpCodes.Refanytype)
        End Sub

        ''' <summary>
        ''' refanyval : Primitive(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Refanyval(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Refanyval, TypeArgument)
        End Sub

        ''' <summary>
        ''' rem : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Rem](Target As ILGenerator)
            Target.Emit(OpCodes.[Rem])
        End Sub

        ''' <summary>
        ''' rem.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Rem_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Rem_Un)
        End Sub

        ''' <summary>
        ''' ret : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ret(Target As ILGenerator)
            Target.Emit(OpCodes.Ret)
        End Sub

        ''' <summary>
        ''' shl : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Shl(Target As ILGenerator)
            Target.Emit(OpCodes.Shl)
        End Sub

        ''' <summary>
        ''' shr : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Shr(Target As ILGenerator)
            Target.Emit(OpCodes.Shr)
        End Sub

        ''' <summary>
        ''' shr.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Shr_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Shr_Un)
        End Sub

        ''' <summary>
        ''' sizeof : Primitive(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Sizeof(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Sizeof, TypeArgument)
        End Sub

        ''' <summary>
        ''' starg : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Starg(Target As ILGenerator, Int16Argument As Int16)
            Target.Emit(OpCodes.Starg, Int16Argument)
        End Sub

        ''' <summary>
        ''' stind.i : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_I(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_I)
        End Sub

        ''' <summary>
        ''' stind.i1 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_I1(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_I1)
        End Sub

        ''' <summary>
        ''' stind.i2 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_I2(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_I2)
        End Sub

        ''' <summary>
        ''' stind.i4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_I4(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_I4)
        End Sub

        ''' <summary>
        ''' stind.i8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_I8(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_I8)
        End Sub

        ''' <summary>
        ''' stind.r4 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_R4(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_R4)
        End Sub

        ''' <summary>
        ''' stind.r8 : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_R8(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_R8)
        End Sub

        ''' <summary>
        ''' stind.ref : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stind_Ref(Target As ILGenerator)
            Target.Emit(OpCodes.Stind_Ref)
        End Sub

        ''' <summary>
        ''' stloc : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc(Target As ILGenerator, Int16Argument As Int16)
            Target.Emit(OpCodes.Stloc, Int16Argument)
        End Sub

        ''' <summary>
        ''' stloc : Primitive(InlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc(Target As ILGenerator, LocalArgument As LocalBuilder)
            Target.Emit(OpCodes.Stloc, LocalArgument)
        End Sub

        ''' <summary>
        ''' stobj : Primitive(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stobj(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Stobj, TypeArgument)
        End Sub

        ''' <summary>
        ''' sub : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Sub](Target As ILGenerator)
            Target.Emit(OpCodes.Sub)
        End Sub

        ''' <summary>
        ''' sub.ovf : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Sub_Ovf(Target As ILGenerator)
            Target.Emit(OpCodes.Sub_Ovf)
        End Sub

        ''' <summary>
        ''' sub.ovf.un : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Sub_Ovf_Un(Target As ILGenerator)
            Target.Emit(OpCodes.Sub_Ovf_Un)
        End Sub

        ''' <summary>
        ''' switch : Primitive(InlineSwitch)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Switch(Target As ILGenerator, LabelArguments As Label())
            Target.Emit(OpCodes.Switch, LabelArguments)
        End Sub

        ''' <summary>
        ''' unbox : Primitive(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Unbox(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Unbox, TypeArgument)
        End Sub

        ''' <summary>
        ''' xor : Primitive(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Xor](Target As ILGenerator)
            Target.Emit(OpCodes.Xor)
        End Sub

#End Region

#Region "Macro"

        ''' <summary>
        ''' beq : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Beq(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Beq, LabelArgument)
        End Sub

        ''' <summary>
        ''' beq.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Beq_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Beq_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' bge : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bge(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bge, LabelArgument)
        End Sub

        ''' <summary>
        ''' bge.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bge_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bge_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' bge.un : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bge_Un(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bge_Un, LabelArgument)
        End Sub

        ''' <summary>
        ''' bge.un.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bge_Un_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bge_Un_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' bgt : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bgt(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bgt, LabelArgument)
        End Sub

        ''' <summary>
        ''' bgt.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bgt_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bgt_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' bgt.un : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bgt_Un(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bgt_Un, LabelArgument)
        End Sub

        ''' <summary>
        ''' bgt.un.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bgt_Un_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bgt_Un_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' ble : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ble(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Ble, LabelArgument)
        End Sub

        ''' <summary>
        ''' ble.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ble_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Ble_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' ble.un : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ble_Un(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Ble_Un, LabelArgument)
        End Sub

        ''' <summary>
        ''' ble.un.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ble_Un_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Ble_Un_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' blt : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Blt(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Blt, LabelArgument)
        End Sub

        ''' <summary>
        ''' blt.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Blt_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Blt_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' blt.un : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Blt_Un(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Blt_Un, LabelArgument)
        End Sub

        ''' <summary>
        ''' blt.un.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Blt_Un_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Blt_Un_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' bne.un : Macro(InlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bne_Un(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bne_Un, LabelArgument)
        End Sub

        ''' <summary>
        ''' bne.un.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Bne_Un_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Bne_Un_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' br.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Br_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Br_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' brfalse.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Brfalse_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Brfalse_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' brtrue.s : Macro(ShortInlineBrTarget)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Brtrue_S(Target As ILGenerator, LabelArgument As Label)
            Target.Emit(OpCodes.Brtrue_S, LabelArgument)
        End Sub

        ''' <summary>
        ''' ldarg.0 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarg_0(Target As ILGenerator)
            Target.Emit(OpCodes.Ldarg_0)
        End Sub

        ''' <summary>
        ''' ldarg.1 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarg_1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldarg_1)
        End Sub

        ''' <summary>
        ''' ldarg.2 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarg_2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldarg_2)
        End Sub

        ''' <summary>
        ''' ldarg.3 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarg_3(Target As ILGenerator)
            Target.Emit(OpCodes.Ldarg_3)
        End Sub

        ''' <summary>
        ''' ldarg.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarg_S(Target As ILGenerator, UInt8Argument As Byte)
            Target.Emit(OpCodes.Ldarg_S, UInt8Argument)
        End Sub

        ''' <summary>
        ''' ldarga.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldarga_S(Target As ILGenerator, UInt8Argument As Byte)
            Target.Emit(OpCodes.Ldarga_S, UInt8Argument)
        End Sub

        ''' <summary>
        ''' ldc.i4.0 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_0(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_0)
        End Sub

        ''' <summary>
        ''' ldc.i4.1 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_1)
        End Sub

        ''' <summary>
        ''' ldc.i4.2 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_2)
        End Sub

        ''' <summary>
        ''' ldc.i4.3 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_3(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_3)
        End Sub

        ''' <summary>
        ''' ldc.i4.4 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_4)
        End Sub

        ''' <summary>
        ''' ldc.i4.5 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_5(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_5)
        End Sub

        ''' <summary>
        ''' ldc.i4.6 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_6(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_6)
        End Sub

        ''' <summary>
        ''' ldc.i4.7 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_7(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_7)
        End Sub

        ''' <summary>
        ''' ldc.i4.8 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_8(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_8)
        End Sub

        ''' <summary>
        ''' ldc.i4.m1 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_M1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldc_I4_M1)
        End Sub

        ''' <summary>
        ''' ldc.i4.s : Macro(ShortInlineI)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldc_I4_S(Target As ILGenerator, Int8Argument As SByte)
            Target.Emit(OpCodes.Ldc_I4_S, Int8Argument)
        End Sub

        ''' <summary>
        ''' ldloc.0 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc_0(Target As ILGenerator)
            Target.Emit(OpCodes.Ldloc_0)
        End Sub

        ''' <summary>
        ''' ldloc.1 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc_1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldloc_1)
        End Sub

        ''' <summary>
        ''' ldloc.2 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc_2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldloc_2)
        End Sub

        ''' <summary>
        ''' ldloc.3 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc_3(Target As ILGenerator)
            Target.Emit(OpCodes.Ldloc_3)
        End Sub

        ''' <summary>
        ''' ldloc.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc_S(Target As ILGenerator, UInt8Argument As Byte)
            Target.Emit(OpCodes.Ldloc_S, UInt8Argument)
        End Sub

        ''' <summary>
        ''' ldloc.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloc_S(Target As ILGenerator, LocalArgument As LocalBuilder)
            Target.Emit(OpCodes.Ldloc_S, LocalArgument)
        End Sub

        ''' <summary>
        ''' ldloca.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldloca_S(Target As ILGenerator, UInt8Argument As Byte)
            Target.Emit(OpCodes.Ldloca_S, UInt8Argument)
        End Sub

        ''' <summary>
        ''' starg.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Starg_S(Target As ILGenerator, UInt8Argument As Byte)
            Target.Emit(OpCodes.Starg_S, UInt8Argument)
        End Sub

        ''' <summary>
        ''' stloc.0 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc_0(Target As ILGenerator)
            Target.Emit(OpCodes.Stloc_0)
        End Sub

        ''' <summary>
        ''' stloc.1 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc_1(Target As ILGenerator)
            Target.Emit(OpCodes.Stloc_1)
        End Sub

        ''' <summary>
        ''' stloc.2 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc_2(Target As ILGenerator)
            Target.Emit(OpCodes.Stloc_2)
        End Sub

        ''' <summary>
        ''' stloc.3 : Macro(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc_3(Target As ILGenerator)
            Target.Emit(OpCodes.Stloc_3)
        End Sub

        ''' <summary>
        ''' stloc.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc_S(Target As ILGenerator, UInt8Argument As Byte)
            Target.Emit(OpCodes.Stloc_S, UInt8Argument)
        End Sub

        ''' <summary>
        ''' stloc.s : Macro(ShortInlineVar)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stloc_S(Target As ILGenerator, LocalArgument As LocalBuilder)
            Target.Emit(OpCodes.Stloc_S, LocalArgument)
        End Sub

#End Region

#Region "Objmodel"

        ''' <summary>
        ''' callvirt : Objmodel(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Callvirt(Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Callvirt, MethodArgument)
        End Sub

        ''' <summary>
        ''' castclass : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Castclass(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Castclass, TypeArgument)
        End Sub

        ''' <summary>
        ''' cpobj : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Cpobj(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Cpobj, TypeArgument)
        End Sub

        ''' <summary>
        ''' initobj : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Initobj(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Initobj, TypeArgument)
        End Sub

        ''' <summary>
        ''' isinst : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Isinst(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Isinst, TypeArgument)
        End Sub

        ''' <summary>
        ''' ldelem : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Ldelem, TypeArgument)
        End Sub

        ''' <summary>
        ''' ldelem.i : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_I(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_I)
        End Sub

        ''' <summary>
        ''' ldelem.i1 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_I1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_I1)
        End Sub

        ''' <summary>
        ''' ldelem.i2 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_I2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_I2)
        End Sub

        ''' <summary>
        ''' ldelem.i4 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_I4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_I4)
        End Sub

        ''' <summary>
        ''' ldelem.i8 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_I8(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_I8)
        End Sub

        ''' <summary>
        ''' ldelem.r4 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_R4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_R4)
        End Sub

        ''' <summary>
        ''' ldelem.r8 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_R8(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_R8)
        End Sub

        ''' <summary>
        ''' ldelem.ref : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_Ref(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_Ref)
        End Sub

        ''' <summary>
        ''' ldelem.u1 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_U1(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_U1)
        End Sub

        ''' <summary>
        ''' ldelem.u2 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_U2(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_U2)
        End Sub

        ''' <summary>
        ''' ldelem.u4 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelem_U4(Target As ILGenerator)
            Target.Emit(OpCodes.Ldelem_U4)
        End Sub

        ''' <summary>
        ''' ldelema : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldelema(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Ldelema, TypeArgument)
        End Sub

        ''' <summary>
        ''' ldfld : Objmodel(InlineField)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldfld(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Ldfld, FieldArgument)
        End Sub

        ''' <summary>
        ''' ldflda : Objmodel(InlineField)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldflda(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Ldflda, FieldArgument)
        End Sub

        ''' <summary>
        ''' ldlen : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldlen(Target As ILGenerator)
            Target.Emit(OpCodes.Ldlen)
        End Sub

        ''' <summary>
        ''' ldobj : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldobj(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Ldobj, TypeArgument)
        End Sub

        ''' <summary>
        ''' ldsfld : Objmodel(InlineField)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldsfld(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Ldsfld, FieldArgument)
        End Sub

        ''' <summary>
        ''' ldsflda : Objmodel(InlineField)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldsflda(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Ldsflda, FieldArgument)
        End Sub

        ''' <summary>
        ''' ldstr : Objmodel(InlineString)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Ldstr(Target As ILGenerator, StringArgument As String)
            Target.Emit(OpCodes.Ldstr, StringArgument)
        End Sub

        ''' <summary>
        ''' newarr : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Newarr(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Newarr, TypeArgument)
        End Sub

        ''' <summary>
        ''' newobj : Objmodel(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Newobj(Target As ILGenerator, ConstructorArgument As ConstructorInfo)
            Target.Emit(OpCodes.Newobj, ConstructorArgument)
        End Sub

        ''' <summary>
        ''' newobj : Objmodel(InlineMethod)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Newobj(Target As ILGenerator, MethodArgument As MethodInfo)
            Target.Emit(OpCodes.Newobj, MethodArgument)
        End Sub

        ''' <summary>
        ''' rethrow : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Rethrow(Target As ILGenerator)
            Target.Emit(OpCodes.Rethrow)
        End Sub

        ''' <summary>
        ''' stelem : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Stelem, TypeArgument)
        End Sub

        ''' <summary>
        ''' stelem.i : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_I(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_I)
        End Sub

        ''' <summary>
        ''' stelem.i1 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_I1(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_I1)
        End Sub

        ''' <summary>
        ''' stelem.i2 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_I2(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_I2)
        End Sub

        ''' <summary>
        ''' stelem.i4 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_I4(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_I4)
        End Sub

        ''' <summary>
        ''' stelem.i8 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_I8(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_I8)
        End Sub

        ''' <summary>
        ''' stelem.r4 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_R4(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_R4)
        End Sub

        ''' <summary>
        ''' stelem.r8 : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_R8(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_R8)
        End Sub

        ''' <summary>
        ''' stelem.ref : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stelem_Ref(Target As ILGenerator)
            Target.Emit(OpCodes.Stelem_Ref)
        End Sub

        ''' <summary>
        ''' stfld : Objmodel(InlineField)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stfld(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Stfld, FieldArgument)
        End Sub

        ''' <summary>
        ''' stsfld : Objmodel(InlineField)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Stsfld(Target As ILGenerator, FieldArgument As FieldInfo)
            Target.Emit(OpCodes.Stsfld, FieldArgument)
        End Sub

        ''' <summary>
        ''' throw : Objmodel(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Throw](Target As ILGenerator)
            Target.Emit(OpCodes.Throw)
        End Sub

        ''' <summary>
        ''' unbox.any : Objmodel(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Unbox_Any(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Unbox_Any, TypeArgument)
        End Sub

#End Region

#Region "Nternal"

        ''' <summary>
        ''' prefix1 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix1(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix1)
        End Sub

        ''' <summary>
        ''' prefix2 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix2(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix2)
        End Sub

        ''' <summary>
        ''' prefix3 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix3(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix3)
        End Sub

        ''' <summary>
        ''' prefix4 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix4(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix4)
        End Sub

        ''' <summary>
        ''' prefix5 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix5(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix5)
        End Sub

        ''' <summary>
        ''' prefix6 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix6(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix6)
        End Sub

        ''' <summary>
        ''' prefix7 : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefix7(Target As ILGenerator)
            Target.Emit(OpCodes.Prefix7)
        End Sub

        ''' <summary>
        ''' prefixref : Nternal(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Prefixref(Target As ILGenerator)
            Target.Emit(OpCodes.Prefixref)
        End Sub

#End Region

#Region "Prefix"

        ''' <summary>
        ''' constrained. : Prefix(InlineType)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Constrained(Target As ILGenerator, TypeArgument As Type)
            Target.Emit(OpCodes.Constrained, TypeArgument)
        End Sub

        ''' <summary>
        ''' readonly. : Prefix(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub [Readonly](Target As ILGenerator)
            Target.Emit(OpCodes.Readonly)
        End Sub

        ''' <summary>
        ''' tail. : Prefix(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Tailcall(Target As ILGenerator)
            Target.Emit(OpCodes.Tailcall)
        End Sub

        ''' <summary>
        ''' unaligned. : Prefix(ShortInlineI)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Unaligned(Target As ILGenerator, Int8Argument As SByte)
            Target.Emit(OpCodes.Unaligned, Int8Argument)
        End Sub

        ''' <summary>
        ''' volatile. : Prefix(InlineNone)
        ''' </summary>
        <Extension()> _
        <DebuggerStepThrough()> _
        Public Sub Volatile(Target As ILGenerator)
            Target.Emit(OpCodes.Volatile)
        End Sub

#End Region

    End Module

End Namespace
