﻿
Imports System.Reflection.Emit

Namespace Emit.Macros

    Friend Class CompareEqualityMethodCollection

        Protected Shared AllFields As New List(Of Field)

        <DebuggerStepThrough()> _
        Private Shared Function TryFind(Generator As ILGenerator, ByRef Result As Field) As Boolean
            For Each i In AllFields
                If i.GeneratorReference.IsAlive AndAlso i.TargetLocal.IsAlive AndAlso i.GeneratorReference.Target Is Generator Then
                    Result = i
                    Return True
                End If
            Next
            Return False
        End Function

        <DebuggerStepThrough()> _
        Public Shared Function GetFields(Generator As ILGenerator, TargetType As Type) As Field
            Dim Method As Field = Nothing
            If Not TryFind(Generator, Method) Then
                Method = New Field(New WeakReference(Of ILGenerator)(Generator), _
                                   New WeakReference(Of LocalBuilder)(Generator.DeclareLocal(TargetType)))
            End If
            Return Method
        End Function

        Public Structure Field
            Public GeneratorReference As WeakReference(Of ILGenerator)
            Public TargetLocal As WeakReference(Of LocalBuilder)
            <DebuggerStepThrough()> _
            Public Sub New(NewGeneratorReference As WeakReference(Of ILGenerator), NewTargetLocal As WeakReference(Of LocalBuilder))
                GeneratorReference = NewGeneratorReference
                TargetLocal = NewTargetLocal
            End Sub
        End Structure

    End Class

End Namespace
