﻿
Imports System.Reflection
Imports System.Reflection.Emit

Namespace Emit.Macros

    ''' <summary>
    ''' Ein Event, das von der <see cref="Macros.EmitEvent"/>-Methode erstellt wurde.
    ''' </summary>
    Public Class EmitEvent

        Dim _EventMember As EventBuilder
        ''' <summary>
        ''' Die <see cref="EventBuilder"/>-Instanz.
        ''' </summary>
        Public ReadOnly Property EventMember As EventBuilder
            <DebuggerStepThrough()> _
            Get
                Return _EventMember
            End Get
        End Property

        Dim _EventField As FieldBuilder
        ''' <summary>
        ''' Das <see cref="FieldBuilder"/>-Feld, das das Delegat-Objekt für das Event beinhaltet.
        ''' </summary>
        Public ReadOnly Property EventField As FieldBuilder
            <DebuggerStepThrough()> _
            Get
                Return _EventField
            End Get
        End Property

        Dim _AddHandlerMethod As MethodBuilder
        ''' <summary>
        ''' Die AddHandler-Methode für das Event.
        ''' </summary>
        Public ReadOnly Property AddHandlerMethod As MethodBuilder
            <DebuggerStepThrough()> _
            Get
                Return _AddHandlerMethod
            End Get
        End Property

        Dim _RemoveHandlerMethod As MethodBuilder
        ''' <summary>
        ''' Die RemoveHandler-Methode für das Event.
        ''' </summary>
        Public ReadOnly Property RemoveHandlerMethod As MethodBuilder
            <DebuggerStepThrough()> _
            Get
                Return _RemoveHandlerMethod
            End Get
        End Property

        ''' <summary>
        ''' Konstruktor.
        ''' </summary>
        <DebuggerStepThrough()> _
        Public Sub New(NewEventMember As EventBuilder, NewEventField As FieldBuilder, NewAddHandlerMethod As MethodBuilder, NewRemoveHandlerMethod As MethodBuilder)
            _EventMember = NewEventMember
            _EventField = NewEventField
            _AddHandlerMethod = NewAddHandlerMethod
            _RemoveHandlerMethod = NewRemoveHandlerMethod
        End Sub

    End Class

End Namespace
