﻿
Imports System.Reflection.Emit

Namespace Emit.Macros

    Friend Class GetObjectAddressMethodCollection

        Protected Shared AllFields As New List(Of Fields)

        <DebuggerStepThrough()> _
        Private Shared Function TryFind(Generator As ILGenerator, ByRef Result As Fields) As Boolean
            For Each i In AllFields
                If i.GeneratorReference.IsAlive AndAlso i.TargetLocal.IsAlive AndAlso i.TypedReferenceLocal.IsAlive AndAlso i.GeneratorReference.Target Is Generator Then
                    Result = i
                    Return True
                End If
            Next
            Return False
        End Function

        <DebuggerStepThrough()> _
        Public Shared Function GetFields(Generator As ILGenerator) As Fields
            Dim Method As Fields = Nothing
            If Not TryFind(Generator, Method) Then
                Method = New Fields(New WeakReference(Of ILGenerator)(Generator), _
                                    New WeakReference(Of LocalBuilder)(Generator.DeclareLocal(GetType(Object))), _
                                    New WeakReference(Of LocalBuilder)(Generator.DeclareLocal(GetType(TypedReference))))
            End If
            Return Method
        End Function

        Public Structure Fields
            Public GeneratorReference As WeakReference(Of ILGenerator)
            Public TargetLocal As WeakReference(Of LocalBuilder)
            Public TypedReferenceLocal As WeakReference(Of LocalBuilder)
            <DebuggerStepThrough()> _
            Public Sub New(NewGeneratorReference As WeakReference(Of ILGenerator), NewTargetLocal As WeakReference(Of LocalBuilder), NewTypedReferenceLocal As WeakReference(Of LocalBuilder))
                GeneratorReference = NewGeneratorReference
                TargetLocal = NewTargetLocal
                TypedReferenceLocal = NewTypedReferenceLocal
            End Sub
        End Structure

    End Class

End Namespace
