﻿
''' <summary>
''' Wird verwendet, um unmögliche Zustände zu behandeln. Beispielsweise ein Select Case, das eigentlich alle möglichen Werte abdeckt, könnte im Else-Zweig eine NopeException auslösen, damit im Falle eines Bugs keine ungültigen Zustände auftreten und der Programmierer auf den Bug aufmerksam wird.
''' </summary>
Public Class NopeException
    Inherits Exception

    <DebuggerStepThrough()> _
    Public Sub New()
        MyBase.New("Nope.")
    End Sub

    <DebuggerStepThrough()> _
    Public Sub New(NewNopeMessage As String)
        MyBase.New("Nope. " & NewNopeMessage)
    End Sub

    <DebuggerStepThrough()> _
    Public Sub New(NewInnerException As Exception)
        MyBase.New("Nope.", NewInnerException)
    End Sub

    <DebuggerStepThrough()> _
    Public Sub New(NewNopeMessage As String, NewInnerException As Exception)
        MyBase.New("Nope. " & NewNopeMessage, NewInnerException)
    End Sub

End Class
