﻿
Namespace Results

    ''' <summary>
    ''' Kapselt eine Angabe über den Erfolg eines Vorganges und einen Fehler, wenn der Vorgang nicht erfolgreich abgeschlossen wurde.
    ''' </summary>
    ''' <typeparam name="TError">Der Typ des Fehlers.</typeparam>
    Public Class ErroredResult(Of TError)
        Inherits Result
        Implements IErroredResult(Of TError)

        Dim _Error As TError
        ''' <summary>
        ''' Der Fehler im Vorgang.
        ''' </summary>
        Public ReadOnly Property [Error] As TError Implements IErroredResult(Of TError).Error
            <DebuggerStepThrough()> _
            Get
                Return _Error
            End Get
        End Property

        ''' <summary>
        ''' Der Vorgang wurde erfolgreich abgeschlossen. Es wurde kein Wert zurückgegeben.
        ''' </summary>
        <DebuggerStepThrough()> _
        Public Sub New()
            MyBase.New(True)
        End Sub

        ''' <summary>
        ''' Der Vorgang wurde nicht erfolgreich abgeschlossen. <paramref name="NewError"/> ist der Fehler im Vorgang.
        ''' </summary>
        <DebuggerStepThrough()> _
        Public Sub New(NewError As TError)
            MyBase.New(False)
            _Error = NewError
        End Sub

    End Class

End Namespace
