﻿
Namespace Results

    ''' <summary>
    ''' Kapselt eine Angabe über den Erfolg eines Vorganges und einen Wert, wenn der Vorgang erfolgreich abgeschlossen wurde.
    ''' </summary>
    ''' <typeparam name="TValue">Der Typ des Wertes.</typeparam>
    Public Class ValuedResult(Of TValue)
        Inherits Result
        Implements IValuedResult(Of TValue)

        Private _Value As TValue
        ''' <summary>
        ''' Der vom Vorgang zurückgegebene Wert.
        ''' </summary>
        Public ReadOnly Property Value As TValue Implements IValuedResult(Of TValue).Value
            <DebuggerStepThrough()> _
            Get
                Return _Value
            End Get
        End Property

        ''' <summary>
        ''' Der Vorgang wurde nicht erfolgreich abgeschlossen. Es wurde kein Wert zurückgegeben.
        ''' </summary>
        <DebuggerStepThrough()> _
        Public Sub New()
            MyBase.New(False)
        End Sub

        ''' <summary>
        ''' Der Vorgang wurde erfolgreich abgeschlossen. <paramref name="NewValue"/> ist der zurückgegebene Wert.
        ''' </summary>
        <DebuggerStepThrough()> _
        Public Sub New(NewValue As TValue)
            MyBase.New(True)
            _Value = NewValue
        End Sub

    End Class

End Namespace
