﻿
''' <summary>
''' Stellt eine Basisklasse für Singletons bereit.
''' Erben Sie von dieser Klasse und geben Sie als Typenparameter die eigene Klasse an, um das Pattern zu implementieren.
''' </summary>
''' <typeparam name="T">Der Typ der <see cref="Singleton(Of Object).Instance"/>-Property. Sollte der Typ sein, auf den ds Singleton-Pattern angewandt wird.</typeparam>
Public MustInherit Class Singleton(Of T As New)

    Private Shared _Instance As T
    ''' <summary>
    ''' Gibt die Instanz dieses Typs zurück bzw. erstellt eine Instanz, wenn dies der erste Aufruf ist.
    ''' </summary>
    Public Shared ReadOnly Property Instance As T
        <DebuggerStepThrough()> _
        Get
            If _Instance Is Nothing Then
                _Instance = New T
            End If
            Return _Instance
        End Get
    End Property

    Protected Sub New()
    End Sub

End Class
