﻿
Namespace Streams

    ''' <summary>
    ''' Enthält die Daten, die <see cref="IDataBufferSource(Of T)"/> bereitgestellt werden..
    ''' </summary>
    ''' <typeparam name="T">Der Typ der Daten.</typeparam>
    Public Class BufferDataReceivedEventArgs(Of T)
        Inherits EventArgs

        Dim _Data As IEnumerable(Of T)
        ''' <summary>
        ''' Die bereitgestellten Daten.
        ''' </summary>
        Public ReadOnly Property Data As IEnumerable(Of T)
            <DebuggerStepThrough()> _
            Get
                Return _Data
            End Get
        End Property

        ''' <summary>
        ''' Konstruktor.
        ''' </summary>
        ''' <param name="NewData">Die bereitgestellten Daten.</param>
        <DebuggerStepThrough()> _
        Public Sub New(NewData As IEnumerable(Of T))
            _Data = NewData
        End Sub

    End Class

End Namespace
