﻿
Namespace Streams

    Friend Class DataBlock(Of T)

        Dim InnerList As List(Of T)

        Public ReadOnly Property Count As Integer
            <DebuggerStepThrough()> _
            Get
                Return InnerList.Count
            End Get
        End Property

        <DebuggerStepThrough()> _
        Public Sub New()
            InnerList = New List(Of T)
        End Sub

        <DebuggerStepThrough()> _
        Private Sub New(NewItems As IEnumerable(Of T))
            InnerList = New List(Of T)(NewItems)
        End Sub

        <DebuggerStepThrough()> _
        Public Sub Append(Value As T)
            InnerList.Add(Value)
        End Sub

        <DebuggerStepThrough()> _
        Public Function ToArray() As T()
            Return InnerList.ToArray
        End Function

        <DebuggerStepThrough()> _
        Public Sub StripAt(Index As Integer)
            InnerList.RemoveRange(Index, InnerList.Count - Index)
        End Sub

        <DebuggerStepThrough()> _
        Public Sub StripEnd(Count As Integer)
            InnerList.RemoveRange(InnerList.Count - Count, Count)
        End Sub

    End Class

End Namespace
