﻿
Namespace Streams

    ''' <summary>
    ''' Stellt Member bereit, die von <see cref="DataBuffer"/> verwendet werden, um Daten zu puffern.
    ''' </summary>
    ''' <typeparam name="T">Der Typ der Daten, die gepuffert werden.</typeparam>
    Public Interface IDataBufferSource(Of T)

        ''' <summary>
        ''' Wird ausgelöst, wenn die Datenquelle neue Daten empfangen hat.
        ''' </summary>
        Event DataReceived As EventHandler(Of BufferDataReceivedEventArgs(Of T))

        ''' <summary>
        ''' Ruft das <see cref="DataReceived"/>-Event für Daten auf, die möglicherweise schon vorhanden sind, jedoch nicht weiterverarbeitet wurden.
        ''' </summary>
        Sub Flush()

        ''' <summary>
        ''' Vergleicht zwei Daten miteinander.
        ''' Gibt True zurück, wenn beide Daten als gleich erachtet werden.
        ''' </summary>
        Function CompareData(Item1 As T, Item2 As T) As Boolean

    End Interface

End Namespace
