﻿
''' <summary>
''' Stellt eine streng typisierte Variante von <see cref="WeakReference"/> dar.
''' </summary>
''' <typeparam name="T">Der Typ des Objektes, das referenziert wird.</typeparam>
Public Class WeakReference(Of T)
    Inherits WeakReference

    ''' <summary>
    ''' Ruft das schwach referenzierte Objekt ab oder legt es fest.
    ''' </summary>
    Public Shadows Property Target As T
        <DebuggerStepThrough()> _
        Get
            Return DirectCast(MyBase.Target, T)
        End Get
        <DebuggerStepThrough()> _
        Set(value As T)
            MyBase.Target = value
        End Set
    End Property

    <DebuggerStepThrough()> _
    Public Sub New(NewTarget As T)
        MyBase.New(NewTarget)
    End Sub

    <DebuggerStepThrough()> _
    Public Sub New(NewTarget As T, TrackResurrection As Boolean)
        MyBase.New(NewTarget, TrackResurrection)
    End Sub

    <DebuggerStepThrough()> _
    Public Sub New(NewSerializationInfo As System.Runtime.Serialization.SerializationInfo, NewStreamingContext As System.Runtime.Serialization.StreamingContext)
        MyBase.New(NewSerializationInfo, NewStreamingContext)
    End Sub

End Class
