﻿
Namespace WinApi

    ''' <summary>
    ''' Beinhaltet WinApi-Aufrufe, die mit Aero-Dekstop-Farbe unter Windows Vista und höher zu tun haben.
    ''' </summary>
    Public NotInheritable Class DwmColorization
        Private Sub New()
        End Sub

        <System.Runtime.InteropServices.StructLayout(Runtime.InteropServices.LayoutKind.Sequential)> _
        Private Structure DwmColorizationParams
            Public ColorizationColor As UInt32
            Public ColorizationAfterglow As UInt32
            Public ColorizationColorBalance As UInt32
            Public ColorizationAfterglowBalance As UInt32
            Public ColorizationBlurBalance As UInt32
            Public ColorizationGlassReflectionIntensity As UInt32
            Public ColorizationOpaqueBlend As UInt32
        End Structure

        <System.Runtime.InteropServices.DllImport("dwmapi.dll", EntryPoint:="#127")> _
        Private Shared Sub DwmGetColorizationParameters(ByRef dp As DwmColorizationParams)
        End Sub

        ''' <summary>
        ''' Ruft die Desktop-Farbe unter Windows 7 und höher ab.
        ''' </summary>
        <DebuggerStepThrough()> _
        Public Shared Function GetDwmColorization() As DwmColor
            Dim Temp As New DwmColorizationParams
            DwmGetColorizationParameters(Temp)
            Return New DwmColor(Temp.ColorizationColor)
        End Function

    End Class

End Namespace
