﻿
Namespace WinApi

    ''' <summary>
    ''' Beinhaltet WinApi-Aufrufe, die mit Maus und Tastatur zu tun haben.
    ''' </summary>
    Public NotInheritable Class MouseAndKeyboard
        Private Sub New()
        End Sub

        <System.Runtime.InteropServices.DllImport("user32.dll")> _
        Private Shared Sub mouse_event(dwFlags As Integer, dx As Integer, dy As Integer, cButtons As Integer, dwExtraInfo As Integer)
        End Sub

        ''' <summary>
        ''' Führt die angegebene <see cref="MouseAction">Maus-Aktion</see> durch.
        ''' </summary>
        ''' <param name="Action">Die Aktion, die durchgeführt wird.</param>
        ''' <param name="X">Die X-Position, an die die Maus verschoben wird.</param>
        ''' <param name="Y">Die Y-Position, an die die Maus verschoben wird.</param>
        <DebuggerStepThrough()> _
        Public Shared Sub MouseEvent(Action As MouseAction, X As Integer, Y As Integer)
            mouse_event(Action, X, Y, 0, 0)
        End Sub

    End Class

End Namespace
