﻿
Namespace Wpf

    ''' <summary>
    ''' Stellt ein <see cref="DelegateCommand"/> dar, bei dem das Ergebnis von <see cref="System.Windows.Input.ICommand.CanExecute"/> geändert werden kann.
    ''' </summary>
    Public Class EnableableDelegateCommand
        Inherits DelegateCommand

        Dim _IsEnabled As Boolean = True
        ''' <summary>
        ''' Gibt an, ob das Command ausgeführt werden kann.
        ''' Der Standardwert ist True.
        ''' </summary>
        Public Property IsEnabled As Boolean
            <DebuggerStepThrough()> _
            Get
                Return _IsEnabled
            End Get
            <DebuggerStepThrough()> _
            Set(value As Boolean)
                If Not _IsEnabled = value Then
                    _IsEnabled = value
                    OnCanExecuteChanged()
                End If
            End Set
        End Property

        <DebuggerStepThrough()> _
        Public Sub New(NewTarget As Action)
            MyBase.New(NewTarget)
        End Sub

        <DebuggerStepThrough()> _
        Public Sub New(NewTarget As Action(Of Object))
            MyBase.New(NewTarget)
        End Sub

        <DebuggerStepThrough()> _
        Public Sub New(NewTarget As Action, NewIsEnabled As Boolean)
            MyBase.New(NewTarget)
            _IsEnabled = NewIsEnabled
        End Sub

        <DebuggerStepThrough()> _
        Public Sub New(NewTarget As Action(Of Object), NewIsEnabled As Boolean)
            MyBase.New(NewTarget)
            _IsEnabled = NewIsEnabled
        End Sub

        <DebuggerStepThrough()> _
        Public Overrides Function CanExecute(Parameter As Object) As Boolean
            Return _IsEnabled
        End Function

    End Class

End Namespace
