﻿
Imports System.Windows
Imports System.Windows.Controls

Namespace Wpf

    Public Class FormatTextBlock
        Inherits TextBlock

        Public WriteOnly Property FormatText As IEnumerable(Of Inline)
            <DebuggerStepThrough()> _
            Set(value As IEnumerable(Of Inline))
                MyBase.Inlines.Clear()
                MyBase.Inlines.AddRange(value)
            End Set
        End Property

        Public Shared ReadOnly FormatTextProperty As DependencyProperty = DependencyProperty.Register("FormatText", GetType(IEnumerable(Of Inline)), GetType(FormatTextBlock), New PropertyMetadata(AddressOf FormatTextDependencyPropertyChanged))

        <DebuggerStepThrough()> _
        Private Shared Sub FormatTextDependencyPropertyChanged(sender As Object, e As DependencyPropertyChangedEventArgs)
            If TypeOf sender Is FormatTextBlock Then
                DirectCast(sender, FormatTextBlock).FormatText = DirectCast(e.NewValue, IEnumerable(Of Inline))
            End If
        End Sub

    End Class

End Namespace
