﻿
Namespace Wpf

    ''' <summary>
    ''' Wird ausgelöst, wenn der ToolTip eines <see cref="ToolTipButton"/> nicht auf ein Objekt des Typs <see cref="System.Windows.Controls.ToolTip"/> festgelegt ist.
    ''' </summary>
    Public Class InvalidToolTipException
        Inherits Exception

        Dim _InvalidObject As Object
        ''' <summary>
        ''' Der Typ des Objektes, das ungültigerweise als ToolTip festgelegt ist.
        ''' </summary>
        Public ReadOnly Property InvalidObject As Object
            <DebuggerStepThrough()> _
            Get
                Return _InvalidObject
            End Get
        End Property

        <DebuggerStepThrough()> _
        Public Sub New(NewInvalidObject As Object)
            MyBase.New("Ein Objekt des Typs " & NewInvalidObject.GetType.FullName & " ist als ToolTip ungültig. Verwenden Sie " & GetType(System.Windows.Controls.ToolTip).FullName)
            _InvalidObject = NewInvalidObject
        End Sub

    End Class

End Namespace
