﻿
Namespace Wpf

    ''' <summary>
    ''' Stellt eine Basisklasse für ViewModels für WPF und MVVM dar.
    ''' Dieses ViewModel ist einem Objekt zugeordnet, das es repräsentiert.
    ''' </summary>
    ''' <typeparam name="T">Der Typ des Objektes, dem das ViewModel zugeordnert ist.</typeparam>
    Public MustInherit Class ViewModelBase(Of T)
        Inherits ViewModelBase

        Dim _Target As T
        ''' <summary>
        ''' Das Objekt, dem dieses ViesModel zugeordnet ist.
        ''' </summary>
        Public Property Target As T
            Get
                Return _Target
            End Get
            Set(value As T)
                ChangeIfDifferent(_Target, value, "Target")
            End Set
        End Property

        ''' <summary>
        ''' Konstruktor. <see cref="Target"/> wird auf Nothing festgelegt.
        ''' </summary>
        Public Sub New()
            _Target = Nothing
        End Sub

        ''' <summary>
        ''' Konstruktor.
        ''' </summary>
        ''' <param name="NewTarget">Das Objekt, dem dieses ViewModel zugeordnet ist. Siehe <see cref="Target"/>.</param>
        Public Sub New(NewTarget As T)
            _Target = NewTarget
        End Sub

    End Class

End Namespace
